'DEMO.BAS
'Run this .BAS to see full screen vertical scrolling
'Tap ENTER to double pixel scroll
'Tap SPACE to halve pixel scroll
'Pixel speeds: 1,2,4,8

'----------------------------------------------------------------------------

'   This program is a serious upgrade to William Yu's SlideShow scrolling demo
'in the ABC packets. I calculated my scrolling engine to be about 7 times
'faster! In fact, as far as I Know, my example is the fastest way possible
'using Basic-only-statements such as PUT and GET. Assembly would be faster I
'suppose, which I am still learning.

'   The VGAPCX.BAS program creates rather large .gfx files (around 2MB). But
'that doesn't really matter because we are using Windows Vcache or Dos
'Smartdrv as a ram disk. This in effect gives Qbasic a HUGE simulated memory!
'Vcache runs automatically under Win95\98 in a Dos box. If you run Qbasic in
'plain Dos, then you must run Smartdrv.exe with 2.3mb of space or more.

'   In case you are wondering, The PCX pics used in the scrolling were screen
'captured from an AMIGA marble game called Ballistix. I used an Amiga
'emulator for my PC computer to do this. You can find C64 and AMIGA emulators
'on the internet (easy!). As well as hundreds of games to download. These can
'give you a lot of ideas for your own Qbasic games!

'   One last thing. In case you try to put sprites in the foreground using
'my scrolling engine, you will find that you will get a lot of flicker. This
'is due to the fact that SCREEN 13 has only 1 video page. To eliminate
'sprite flickering, you must use 2 or more video pages. I recently read an
'article in a large assembly book, that explains how to simulate up to 4
'video pages in video mode 13h (SCREEN 13). As soon as I learn machine
'language I will update this demo for using sprites. Otherwise you must
'modify things to use SCREEN 7, which has 8 video pages to eliminate sprite
'flicker. Currently I am working on a half screen scrolling demo that can use sprites
'flicker free sprites in SCREEN 7 mode. SCREEN 7 (16 color) scrolling is a lot
'slower than SCREEN 13 (256 color) by the way.

'----------------------------------------------------------------------------

ON ERROR GOTO erreur

 DEFINT A-Z
 SCREEN 13
 DIM gph%(32766)
 DEF SEG = VARSEG(gph%(0))
 CLS

'*********************************
'load palette
'*********************************
OPEN "Balpal.dat" FOR INPUT AS #1
FOR xj = 0 TO 255
    OUT &H3C8, xj
    INPUT #1, pal: OUT &H3C9, pal
    INPUT #1, pal: OUT &H3C9, pal
    INPUT #1, pal: OUT &H3C9, pal
NEXT xj
CLOSE #1
  
'***********************************************
' bloads graphics into ram disk(vcache\smartdrv)
'***********************************************
   PRINT "Please wait..."
   DO
     num = num + 1
     f$ = "balbsv" + LTRIM$(STR$(num)) + ".gfx"
     BLOAD f$, VARPTR(gph%(0))
   LOOP UNTIL num = 38
   
'**********************************************
'loop that does the actual scrolling
'**********************************************
    num = 1: a = 1: b = 8: c = 0: d = -1
    ct = 1: d1 = 1: d2 = -1
   
    DO
      a$ = INKEY$
      IF a$ = CHR$(13) OR a$ = CHR$(32) THEN GOSUB 100
      f$ = "Balbsv" + LTRIM$(STR$(num)) + ".gfx"       ' balbsv_.gfx
      BLOAD f$, VARPTR(gph%(0))                        '
     
      IF b = 8 THEN           '
        yb = b + d            '
        aj = 8                ' Eleviate
      ELSE                    ' ugly
        yb = b + d            ' edge
        aj = 0                ' bleed.
      END IF                  '
      PUT (0, aj), gph%, PSET '
     
      '********************************
      'scroll 8 steps forward or back
      '********************************
      FOR y = yb TO c STEP d
        'FOR delay& = 1 TO 80000: NEXT    'optional delay
        'WAIT &H3DA, 8                    'optional vertical retrace
        PUT (0, y), gph%, PSET
      NEXT y
     
      '**********************************
      'reverse values to bounce other way
      '**********************************
      num = num + a
      IF num = 39 THEN
        num = 38: a = -1: b = 0: c = 8: d = d1
      END IF
      IF num = 0 THEN
        num = 1: a = 1: b = 8: c = 0: d = d2
      END IF
    LOOP

'*****************************************************************
'Subroutine uses keyboard input to speed up or slow down scrolling
'*****************************************************************
100 : IF a$ = CHR$(13) AND ct < 7 THEN
        ct = ct * 2                        'speed up
        d1 = ct: d2 = ct * -1              '
      ELSEIF a$ = CHR$(32) AND ct > 1 THEN
        ct = ct / 2                        'slow down
        d1 = ct: d2 = ct * -1              '
      END IF
                                             
      IF b = 8 THEN
        d = d2
      ELSEIF b = 0 THEN
        d = d1
      END IF
     
      LOCATE 14, 11
      PRINT ct; "pixel scrolling";
      FOR q& = 1 TO 900000: NEXT
RETURN
erreur:
RESUME NEXT

